<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="modal">
        <div class="modal-mask"></div>
        <button class="close-btn button-icon" @click="closeModal();">
            <i class="icon-close"></i>
        </button>
        <div class="modal-wrapper">
            <div class="modal-sidebar">
                <div>
                    <h2 v-if="edit">Edit <br>Domain</h2>
                    <h2 v-else>Create <br>New <br>Domain</h2>
                    <div>
                        <nav>
                            <ul>
                                <li :class="{ 'active' : currentStep === 1 }"><div><span>1</span>Domain Info</div></li>
                                <!-- <li :class="{ 'active' : currentStep === 2 }"><a @click="gotoStep(2)"><span>2</span>Confirmation</a></li> -->
                            </ul>
                        </nav>
                    </div>
                </div>
                <div>
                    <div class="info user">
                        <h3>Owner</h3>
                        <UserProfile />
                    </div>
                    <InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
                </div>
            </div>
            <div class="modal-content">
                <!-- ==== STEP 1 - Term Info ====  -->
                <div id="step-1" class="step" v-show="currentStep === 1">
                    <form id="dataset-step-1" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">1</span>
                            <h2>Domain info</h2>
                            <p>Define a new domain to organize and categorize your datasets more effectively. Provide a clear and concise name and description to ensure proper identification and usage.</p>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>1.</span>Domain name</label>
                                <input type="text" name="name" required :value="edit ? data?.name : ''" :disabled="edit" data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>2.</span>Fill in with the Basic Info</label>
                            </div>
                            <div class="modal-boxs-wrapper">
                                <div class="modal-input col-100">
                                    <label for="full-description">Full description</label>
                                    <input type="text" name="full-description" id="full-description" :value="edit ? data?.description : ''" required data-error-message="Fill in this field."/>
                                </div>
                                <!-- <div class="modal-input col-100">
                                    <label for="short-description">Short description</label>
                                    <input type="text" name="short-description" id="short-description"/>
                                </div> -->
                            </div>
                            <!-- <div class="field field-modal-big-label">
                                <label for="" class="label"><span>3.</span>Set the relations for this domain</label>
                            </div> -->
                            <!-- <div class="modal-boxs-wrapper">
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Quality Rules</h3>
                                        <div class="search-wrapper">
                                            <input type="text" name="platform-search" class="input-search">
                                        </div>
                                    </div>
                                    <ul class="modal-box-checkbox-list modal-box-checkbox-list-ball">
                                        <li v-for="platform in platforms" :key="platform?.id">
                                            <input type="checkbox" :id="`platform-${platform?.id}`" />
                                            <label :for="`platform-${platform?.id}`">{{ platform?.name }}</label>
                                        </li>
                                    </ul>
                                </div>
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Vocabularies</h3>
                                        <div class="search-wrapper">
                                            <input type="text" name="platform-search" class="input-search">
                                        </div>
                                    </div>
                                    <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                        <li v-for="domain in domains" :key="domain?.id">
                                            <input type="checkbox" :id="`domain-${domain?.id}`" />
                                            <label :for="`domain-${domain?.id}`">{{ domain?.name }}</label>
                                        </li>
                                        <li>
                                            <span>
                                                <i class="icon-add add"></i>
                                                312
                                                <i class="icon-arrow-down arrow"></i>
                                            </span>
                                        </li>
                                    </ul>
                                </div>
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Terms - Synonyms</h3>
                                        <div class="search-wrapper">
                                            <input type="text" name="platform-search" class="input-search">
                                        </div>
                                    </div>
                                    <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                        <li v-for="domain in domains" :key="domain?.id">
                                            <input type="checkbox" :id="`domain-${domain?.id}`" />
                                            <label :for="`domain-${domain?.id}`">{{ domain?.name }}</label>
                                        </li>
                                        <li>
                                            <span>
                                                <i class="icon-add add"></i>
                                                312
                                                <i class="icon-arrow-down arrow"></i>
                                            </span>
                                        </li>
                                    </ul>
                                </div>
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Terms - Antonyms</h3>
                                        <div class="search-wrapper">
                                            <input type="text" name="platform-search" class="input-search">
                                        </div>
                                    </div>
                                    <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                        <li v-for="domain in domains" :key="domain?.id">
                                            <input type="checkbox" :id="`domain-${domain?.id}`" />
                                            <label :for="`domain-${domain?.id}`">{{ domain?.name }}</label>
                                        </li>
                                        <li>
                                            <span>
                                                <i class="icon-add add"></i>
                                                312
                                                <i class="icon-arrow-down arrow"></i>
                                            </span>
                                        </li>
                                    </ul>
                                </div>
                            </div> -->
                        </div>
                    </form>
                </div>

                <!-- ==== STEP 2 - Confirmation === -->
                <!-- <div id="step-2" class="step" v-show="currentStep === 2">
                    <div class="title">
                        <span class="step-number">2</span>
                        <h2>Confirmation</h2>
                        <p>Please review the details to ensure accuracy before create a new Domain.</p>
                    </div>
                    <div class="confirmation-wrapper">
                        <div class="confirmation-wrapper-values">
                            <div class="card-values">
                                <div class="card-values-number">14</div>
                                <div class="card-values-text">quality rules</div>
                            </div>
                            <div class="card-values">
                                <div class="card-values-number">23</div>
                                <div class="card-values-text">vocabularies</div>
                            </div>
                            <div class="card-values">
                                <div class="card-values-number">3</div>
                                <div class="card-values-text">synonyms</div>
                            </div>
                            <div class="card-values">
                                <div class="card-values-number">9</div>
                                <div class="card-values-text">antonyms</div>
                            </div>
                        </div>
                        <button class="button-secondary orange" @click="closeModal"><span v-if="edit">Confirm and Edit Domain</span><span v-else>Confirm and Create Domain</span></button> 
                    </div>
                </div> -->

            </div>
            <div class="modal-buttons-area">
                <button :class="['button-stroke-transparent rounded', currentStep === 1 && 'hide']" id="previous-step" @click="previousStep">Back</button>
                <button class="button-secondary orange" id="next-step" @click="handleNextClick"><span v-if="edit">Save</span><span v-else>Create</span></button>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">

import { highlightInvalidFields, updateLoadingUI, clearAllValidationErrors } from '~/utils/utils';
const props = defineProps({
    edit: { 
        type: Boolean, 
        required: false 
    },
    data: {
        type: Object,
        required: false
    }
});

const emit = defineEmits(['toggle', 'refresh-data']);

const closeModal = () => {
    emit('toggle');
    emit('refresh-data');
}

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);
const close = () => {
    showFeedback.value = false;
};

interface platformArray {
    id: number;
    name: string;
}

interface Term {
    id: number;
    name: string;
}

const platforms = ref<platformArray[]>([
    {
        id: 1,
        name: 'AWS S3'
    },
    {
        id: 2,
        name: 'Looker'
    },
    {
        id: 3,
        name: 'Big Query'
    },
    {
        id: 4,
        name: 'Looker'
    },
    {
        id: 5,
        name: 'Big Query'
    },
    {
        id: 6,
        name: 'AWS S3'
    },
    {
        id: 7,
        name: 'AWS S3'
    },
    {
        id: 8,
        name: 'AWS S3'
    },
    {
        id: 9,
        name: 'Big Query'
    }
])

const domains = ref<platformArray[]>([
    {
        id: 1,
        name: 'Mathematics'
    },
    {
        id: 2,
        name: 'Computer Sciente / Finance'
    },
    {
        id: 3,
        name: 'Medicine / Health Sciences'
    },
    {
        id: 4,
        name: 'Civil Engineering'
    },
    {
        id: 5,
        name: 'Computer Science / Artificial Intelligence'
    }
])


// modal navigation

const currentStep = ref<number>(1);

interface DomainData {
  name: string;
  description: string;
  parent: string | null;
  subDomains: string[];
}

// form submit step 1
const handleSubmit = () => {
    const form = document.getElementById('dataset-step-1') as HTMLFormElement;

    if (currentStep.value === 1) {
        
        if (!form.checkValidity()) {
            // Report validity and highlight invalid fields
            form.reportValidity();
            highlightInvalidFields(form);
            console.log('Form is invalid, showing error messages or highlighting fields.');
            return; // Prevent further execution if the form is invalid
        }

            
        const formData = new FormData(form);

        const data = {
            name: formData.get('name') as string,
            description: formData.get('full-description') as string,
            parent: null,
            subDomains: []
        };

        // Show loading state
        updateLoadingUI(true);

        try {
            // Submit the data
            if(props?.edit){
                submitDataUpdate(data, props?.data?.name)
            }else{
                submitData(data);
                form.reset();
            }
           
            console.log('Data submitted successfully: (request)', data);

            // Clear the form and validation errors after successful submission
            
            clearAllValidationErrors(form);
            // Close modal
            //closeModal();
        } catch (error) {
            console.error('Error during data submission:', error);
        } finally {
            // Always stop the loading indicator
            updateLoadingUI(false);
        }
    } else {
        nextStep(); // If not step 1, simply go to the next step
    }
}


const submitData = (data: DomainData) => {
    try {
        useFetchAuth('/domains', { 
            method: 'POST', 
            headers: {
            'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }).then((response: any) => {
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'success',
                message: 'Domain added successfully!',
            };
            console.log('Domain added successfully:', response);
            setTimeout(() => {
                feedbackMessage.value = { type: '', message: '' };
                showFeedback.value = false;
                closeModal();
            }, 3000);
        }).catch((error) => {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error adding domain:' + errorData,
            };
            return;
        });
    } catch (error) {
        showFeedback.value = true;
        feedbackMessage.value = {
            type: 'error',
            message: 'Error adding domain:' + error,
        };
        console.error('Error during fetch:', error);
    }
}

const submitDataUpdate = async (data: DomainData, domainName: string) => {
    try {
        useFetchAuth('/domains/' + domainName, { 
            method: 'PUT',
            headers: {
            'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }).then((response: any) => {
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'success',
                message: 'Domain updated successfully!',
            };
            console.log('Domain updated successfully:', response);
            setTimeout(() => {
                feedbackMessage.value = { type: '', message: '' };
                showFeedback.value = false;
                closeModal();
            }, 3000);
        }).catch((error) => {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error updating domain:' + errorData,
            };
            return;
        });
    } catch (error) {
        showFeedback.value = true;
        feedbackMessage.value = {
            type: 'error',
            message: 'Error updating domain:' + error,
        };
        console.error('Error during fetch:', error);
    }
}

const handleNextClick = () => {
      if (currentStep.value === 1) {
        // Trigger form submission and validation only on step 1
        handleSubmit();
      } else {
        // Proceed to the next step without form submission
        nextStep();
      }
    }

const nextStep = () => {
    if (currentStep.value < 2) {
        currentStep.value++;
    }
}

const previousStep = () => {
    if (currentStep.value > 0) {
        currentStep.value--;
    }
}

const gotoStep = (step: number) => {
    currentStep.value = step;
}

</script>